/*
      Examine topology of the lattice (sorted bound-matrix).
        - read lattice from file -> MODELFILE=daten.def 
        - neu: datensaetze zeilen statt spaltenweise (12-1997)
        
        Isomorphie von (ungerichteten endlichen) Graphen
 */
#include <stdlib.h>
#include <stdio.h>
#define NN       36		/* maximum number of sites */
#define MODELFILE "daten.def"
#define F0(x0)       {fprintf(stderr,x0);exit(1);}
#define E0(x0)       {fprintf(stderr,x0);exit(1);}

int	vvv=1;			/* verbose */
int     nn=0;			/* number of size */

int ww_out(const int w2w[NN][NN],const int w2[NN]){
  int i,j;
  if(w2)for(i=0;i<nn;i++)printf(" %2d",w2[i]);printf(" =IDX\n");
  if(w2w)for(j=0;j<nn;j++){
   for(i=0;i<nn;i++)printf("%2d",w2w[(w2)?w2[j]:j][(w2)?w2[i]:i]);
   printf("\n");}
  return 0;}

/* versucht rekursiv next index zu minimieren, max. Tiefe num==nn */
int sort0_rekurs(const int w2w[NN][NN],int w2[NN],int w2min[NN],int num){
  /* evl. vorher testen und abwuergen (return 1), geht nur bei diag=0 */
  int i,j,k,w3[NN],m1,m2;

  for(m1=m2=j=((num>0)?num-1:0);j<num;j++)for(i=0;i<j;i++)
    if((m1=w2w[w2[j]][w2[i]])!=(m2=w2w[w2min[j]][w2min[i]])){j=nn;break;}
  if(m1<m2){ for(i=0;i<nn;i++)w2min[i]=w2[i];ww_out(w2w,w2min); }
  if(num>=nn-1) return 0;
  if(m1>m2) return 1;	/* Suchbaum abschneiden */
  
  for(i=0;i<nn;i++)w3[i]=w2[i]; 	/* minimale Matrix */
  		/* suche kleinste Zeile i=[num..nn] im Bereich 0..num */
  i=num;
  for(j=num+1;j<nn;j++){		/* change next index */
    for(k=0;k<j;k++)
     if((m1=w2w[w2[j]][w2[k]])!=(m2=w2w[w2[i]][w2[k]])) break;
    if(m1<m2) i=j;
  }
  				/* suche tiefer bei Zeilen = i */
  for(j=num;j<nn;j++){			/* change next index */
   for(k=0;k<j;k++)
     if((m1=w2w[w2[i]][w2[k]])!=(m2=w2w[w2[j]][w2[k]]))break;
   if(k<j)continue;
   k=w3[num];w3[num]=w3[j];w3[j]=k;	/* exchange j with num */
   sort0_rekurs(w2w,w3,w2min,num+1);
   for(k=0;k<nn;k++)w3[k]=w2[k];	/* restore */
  }
  return 0;}

int ww0_sort(const int w2w[NN][NN],int w2min[NN]){
  int i,w2[NN];
  for(i=0;i<nn;i++)w2min[i]=w2[i]=i;   /* minimale+aktuelle Matrix */
  sort0_rekurs(w2w,w2,w2min,0); 
  return 0;}


int ww2_sort(const int w2w[NN][NN],int w2[NN]){
  int i,j,k,fsort,is,w1,w3[NN],m1,m2;
  /* pruefe, ob eindeutig! */
  srand(1);
  for(i=0;i<nn;i++)w3[i]=w2[i]=i;
  for(is=0;is<8192;is++){
    do { fsort=1;   /* flag sorted */
      for(i=0;i<nn;i++){ 
        for(j=i+1;j<nn;j++){   /* zeile i>j ? dann tausche */
          if((m1=w2w[w2[i]][w2[i]])==(m2=w2w[w2[j]][w2[j]]))
          for(k=0;k<nn;k++)if(k!=j && k!=i)
          if((m1=w2w[w2[i]][w2[k]])!=(m2=w2w[w2[j]][w2[k]]))break;
          if(m1>m2){
            w1=w2[j];w2[j]=w2[i];w2[i]=w1;fsort=0; /* tausche zeilen */ 
          } 
        }
      }
    } while (!fsort); /* until sorted */ 
    /* ww_out(w2w,w2); */
    /* minimum? */
    for(j=0;j<nn;j++)for(i=0;i<nn;i++)
      if((m1=w2w[w2[j]][w2[i]])!=(m2=w2w[w3[j]][w3[i]])){ j=nn;break; }
    if(m1<m2) { for(i=0;i<nn;i++)w3[i]=w2[i];
      ww_out(w2w,w3);printf(" cycle=%u\n",is); }
    for(i=0;i<nn;i++){ j=rand()%nn;k=w2[i];w2[i]=w2[j];w2[j]=k; }
  }  
  srand(0);
  for(i=0;i<nn;i++)w2[i]=w3[i];
  return 0;}


/*
 *  # +++model+++
 *  # NN Nw Nv
 *    2  1  0
 *  # s  X  Y  Z  e  U
 *    0  0  0  0  0  0
 *    1  1  0  0  0  0
 *  # n s1 s2  t  J  V
 *    0  0  1  2  1  0
 *  # ---model---
 */

int ww_load(int w2w[NN][NN]){
    int i,j,k,err,ll, idx,pos[3],we,wu, iw[2],wt,wj,
        nw /* number of bonds */ ;
    FILE *f1;char s1[1024];
    for(i=0;i<NN;i++)for(j=0;j<NN;j++)w2w[i][j]=0;
    i=j=k=nw=nn=0;
    f1=fopen(MODELFILE,"rt");if(!f1)F0("open file "MODELFILE);
    if(vvv)printf(" read "MODELFILE);ll=0;
    do { if(!fgets(s1,1023,f1))F0("read");ll++; } while(*s1=='#');
    sscanf(s1,"%d%d%d",&nn,&nw,&k);if(nn>NN || 0!=k){ 
      printf(" NN=%d Nw=%d Nv=%d s=%s",nn,nw,k,s1);
      F0(" error in definitions of NN Nw Nv");}
    for(i=0;i<nn;i++){
      do { if(!fgets(s1,1023,f1))F0("read");ll++; } while(*s1=='#');
      sscanf(s1,"%d%d%d%d%d%d",&idx,&pos[0],&pos[1],&pos[2],&we,&wu);
      if(idx<0 || idx>=nn)F0("idx out of range 0..NN-1");
#if 0
      w2w[idx][idx]=wu*nn+we;
#endif
      }
    for(i=0;i<nw;i++){ 
      do { if(!fgets(s1,1023,f1))F0("read");ll++; } while(*s1=='#');
      sscanf(s1,"%u%d%d%d%d%d",&j,&iw[0],&iw[1],&wt,&wj,&k);
      err=0; if(j>=nw)err=1; if(i!=j )err=2; if(k!=0 )err=3;
      if(iw[0]<0 || iw[0]>=nn || iw[1]<0 || iw[1]>=nn)err=4;
      if(w2w[iw[0]][iw[1]])err=5;
      if(err){
        printf(" LINE %d: %2d n=%2d s1=%2d s2=%2d\n",ll,i,j,iw[0],iw[1]);
        if(err==1)F0("out of range 0..Nw-1");
        if(err==2)E0(" idx!=n");
        if(err==3)E0("V!=0 not implemented yet");
        if(err==4)F0(" iw out of range 0..NN-1");
        if(err==5)E0("Warning: bound %d-%d twice defined");
      }  
      w2w[iw[0]][iw[1]]=w2w[iw[1]][iw[0]]=/* wt*nw+ */wj;
    }
    fclose(f1);
    if(vvv)printf("\n");
    return 0;}    

int main(){
   int w2w[NN][NN];
   int wi[NN];
   ww_load(w2w);
   ww_out(w2w,NULL);
   ww2_sort(w2w,wi);
   ww_out(w2w,wi);
   return 0;}
